module robject;
import std.string;
import std.conv;

/*
 * Nesnelerin işlevlerini içeren arayüz.
*/
class RObject{
	RObject opCall(RObject[] parameters){
		throw new Exception("Bu türü çağıramazsınız.");
	}
	RObject opAdd(RObject){
		throw new Exception("Bu türde toplama yapamazsınız.");
	}
	RObject opMul(RObject){
		throw new Exception("Bu türde çarpma yapamazsınız.");
	}
	RObject opDiv(RObject){
		throw new Exception("Bu türde bölme yapamazsınız.");
	}
	RObject opSub(RObject){
		throw new Exception("Bu türde çıkartma yapamazsınız.");
	}
	override @property string toString(){
		throw new Exception("Bu türü string yapamazsınız.");
	}
}

class RFunction : RObject{
	string name;
	RObject function(RObject[]) func;
	this(string name, RObject function(RObject[]) func){
		this.name = name;
		this.func = func;
	}
	override:
	@property string toString(){
		return "[Fonksiyon: %s, Adres: %s]".format(name, &func);
	}
	RObject opCall(RObject[] parameters){
		return func(parameters);
	}
}

class RBoolean : RObject{
	bool value;
	this(bool value){
		this.value = value;
	}
	override:
	@property string toString(){
		return to!string(value);
	}
}

class RNumber : RObject{
	int value;
	this(int value){
		this.value = value;
	}
	override:
	@property string toString(){
		return to!string(value);
	}
	RObject opAdd(RObject t){
		return new RNumber(this.value + (cast(RNumber) t).value);
	}
	RObject opMul(RObject t){
		return new RNumber(this.value * (cast(RNumber) t).value);
	}
	RObject opDiv(RObject t){
		return new RNumber(this.value / (cast(RNumber) t).value);
	}
	RObject opSub(RObject t){
		return new RNumber(this.value - (cast(RNumber) t).value);
	}
}

class RString : RObject{
	string value;
	this(string value){
		this.value = value;
	}
	override:
	@property string toString(){
		return to!string(value);
	}
	RObject opAdd(RObject t){
		return new RString(this.value ~ (cast(RString) t).value);
	}
}